Bug 1314120 - [RFE] Unify scrub into the client queue
Summary: [RFE] Unify scrub into the client queue
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Ceph Storage
Classification: Red Hat
Component: RADOS
Version: 2.0
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: 2.0
Assignee: Samuel Just
QA Contact: shylesh
Bara Ancincova
URL:
Whiteboard:
Depends On:
Blocks: 1322504
TreeView+ depends on / blocked
 
Reported: 2016-03-03 00:15 UTC by Samuel Just
Modified: 2017-07-30 15:10 UTC (History)
11 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
.Scrub operations are now in the client queue The scrub and trimming operations have been moved to the client operations queue to prioritize client I/O more accurately.
Clone Of:
Environment:
Last Closed: 2016-08-23 19:32:59 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Ceph Project Bug Tracker 8635 None None None 2016-03-03 00:19:48 UTC
Red Hat Product Errata RHBA-2016:1755 normal SHIPPED_LIVE Red Hat Ceph Storage 2.0 bug fix and enhancement update 2016-08-23 23:23:52 UTC

Description Samuel Just 2016-03-03 00:15:26 UTC
Description of problem:

Previously, snap trimming and scrub happened in a background thread pool meaning that scrub and snap trimming were scheduled vs client ops at the whim of the os scheduler.  Instead, move them into the same queue with lower priority so that the queue implementation can prioritize client IO directly while avoid starvation.

The main things to test are:
1) scrub throughput is adequate when cluster is not loaded

For this, populate a cluster to let's say 50% full of a mix of rbd and radosgw objects (make sure no single radosgw bucket gets unreasonably large).  Initiate a scrub, make sure the progress is reasonable (doesn't hang, comparable to hammer completion time).  Scrubbing a single pg on a 3 osd cluster is probably adequate.

2) client IO latency doesn't suffer too much (hopefully improves!) compared with hammer during a scrub (deep and shallow)

Populate the cluster as above.  Pick a few precreated rbd images and run fio small writes. Record 99th percentile latency and average throughput while scrubbing (you can probably just set the scrub interval to be very so that they are always scrubbing).  Verify that these do not suffer compared with hammer.

Comment 3 Neil Levine 2016-03-03 00:23:48 UTC
Acking this for 2.0 but it needs a conversation with QE to confirm they feel this can be tested.

Comment 12 Ben England 2016-07-19 16:15:51 UTC
not clear if Sam is talking about scrubbing, deep scrubbing or both?  Scrubbing just scans metadata right? which may just be cached for our small disk drives when large RBD objects are used.

-ben

Comment 14 errata-xmlrpc 2016-08-23 19:32:59 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHBA-2016:1755


Note You need to log in before you can comment on or make changes to this bug.